testautomation_audio.c File Reference
`#include <stdio.h>`
`#include <string.h>`
`#include "SDL.h"`
`#include "SDL_test.h"`
Include dependency graph for testautomation_audio.c:

Go to the source code of this file.

## Macros

#define | _CRT_SECURE_NO_WARNINGS

## Functions

void | _audioSetUp (void *arg)
void | _audioTearDown (void *arg)
void | _audio_testCallback (void *userdata, Uint8 *stream, int len)
int | audio_quitInitAudioSubSystem ()
| Stop and restart audio subsystem. More...
int | audio_initQuitAudio ()
| Start and stop audio directly. More...
int | audio_initOpenCloseQuitAudio ()
| Start, open, close and stop audio. More...
int | audio_pauseUnpauseAudio ()
| Pause and unpause audio. More...
int | audio_enumerateAndNameAudioDevices ()
| Enumerate and name available audio devices (output and capture). More...
int | audio_enumerateAndNameAudioDevicesNegativeTests ()
| Negative tests around enumeration and naming of audio devices. More...
int | audio_printAudioDrivers ()
| Checks available audio driver names. More...
int | audio_printCurrentAudioDriver ()
| Checks current audio driver name with initialized audio. More...
int | audio_buildAudioCVT ()
| Builds various audio conversion structures. More...
int | audio_buildAudioCVTNegative ()
| Checkes calls with invalid input to SDL_BuildAudioCVT. More...
int | audio_getAudioStatus ()
| Checks current audio status. More...
int | audio_openCloseAndGetAudioStatus ()
| Opens, checks current audio status, and closes a device. More...
int | audio_lockUnlockOpenAudioDevice ()
| Locks and unlocks open audio device. More...
int | audio_convertAudio ()
| Convert audio using various conversion structures. More...
int | audio_openCloseAudioDeviceConnected ()
| Opens, checks current connected status, and closes a device. More...

## Variables

int | _audio_testCallbackCounter
int | _audio_testCallbackLength
const int | _numAudioFormats = 18
SDL_AudioFormat | _audioFormats []
char * | _audioFormatsVerbose []
const int | _numAudioChannels = 4
Uint8 | _audioChannels [] = { 1, 2, 4, 6 }
const int | _numAudioFrequencies = 4
int | _audioFrequencies [] = { 11025, 22050, 44100, 48000 }
static const SDLTest_TestCaseReference | audioTest1
static const SDLTest_TestCaseReference | audioTest2
static const SDLTest_TestCaseReference | audioTest3
static const SDLTest_TestCaseReference | audioTest4
static const SDLTest_TestCaseReference | audioTest5
static const SDLTest_TestCaseReference | audioTest6
static const SDLTest_TestCaseReference | audioTest7
static const SDLTest_TestCaseReference | audioTest8
static const SDLTest_TestCaseReference | audioTest9
static const SDLTest_TestCaseReference | audioTest10
static const SDLTest_TestCaseReference | audioTest11
static const SDLTest_TestCaseReference | audioTest12
static const SDLTest_TestCaseReference | audioTest13
static const SDLTest_TestCaseReference | audioTest14
static const SDLTest_TestCaseReference | audioTest15
static const SDLTest_TestCaseReference * | audioTests []
SDLTest_TestSuiteReference | audioTestSuite

## Macro Definition Documentation

#define _CRT_SECURE_NO_WARNINGS

Original code: automated SDL audio test written by Edgar Simo "bobbens" New/updated tests: aschiffler at ferzkopp dot net

Definition at line 7 of file testautomation_audio.c.

## Function Documentation

void _audio_testCallback | ( | void * | userdata,
|  | Uint8 * | stream,
|  | int | len
| ) |  |

Definition at line 49 of file testautomation_audio.c.

References _audio_testCallbackCounter, and _audio_testCallbackLength.

Referenced by audio_initOpenCloseQuitAudio(), audio_lockUnlockOpenAudioDevice(), audio_openCloseAndGetAudioStatus(), audio_openCloseAudioDeviceConnected(), and audio_pauseUnpauseAudio().

{
/* track that callback was called */
_audio_testCallbackCounter++;
_audio_testCallbackLength += len;
}
len
GLenum GLsizei len
Definition: SDL_opengl_glext.h:2926
_audio_testCallbackLength
int _audio_testCallbackLength
Definition: testautomation_audio.c:45
_audio_testCallbackCounter
int _audio_testCallbackCounter
Definition: testautomation_audio.c:42

void _audioSetUp | ( | void * | arg | ) |

Definition at line 20 of file testautomation_audio.c.

References SDL_GetError, SDL_INIT_AUDIO, SDL_InitSubSystem, SDLTest_AssertCheck(), SDLTest_AssertPass(), and SDLTest_LogError().

Referenced by audio_initOpenCloseQuitAudio(), audio_initQuitAudio(), audio_pauseUnpauseAudio(), and audio_quitInitAudioSubSystem().

{
/* Start SDL audio subsystem */
int ret = SDL_InitSubSystem( SDL_INIT_AUDIO );
SDLTest_AssertPass("Call to SDL_InitSubSystem(SDL_INIT_AUDIO)");
SDLTest_AssertCheck(ret==0, "Check result from SDL_InitSubSystem(SDL_INIT_AUDIO)");
if (ret != 0) {
SDLTest_LogError("%s", SDL_GetError());
}
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:119
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_InitSubSystem
#define SDL_InitSubSystem
Definition: SDL_dynapi_overrides.h:61
SDLTest_LogError
void SDLTest_LogError(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and the ERROR priority.
Definition: SDL_test_log.c:89
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_INIT_AUDIO
#define SDL_INIT_AUDIO
Definition: SDL.h:76

void _audioTearDown | ( | void * | arg | ) |

Definition at line 32 of file testautomation_audio.c.

References SDLTest_AssertPass().

{
/* Remove a possibly created file from SDL disk writer audio driver; ignore errors */
remove("sdlaudio.raw");
SDLTest_AssertPass("Cleanup of test files completed");
}
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94

int audio_buildAudioCVT | ( |  | ) |

Builds various audio conversion structures.

See also
  https://wiki.libsdl.org/SDL_BuildAudioCVT

Definition at line 515 of file testautomation_audio.c.

References _audioChannels, _audioFormats, _audioFormatsVerbose, _audioFrequencies, _numAudioChannels, _numAudioFormats, _numAudioFrequencies, AUDIO_S16LSB, AUDIO_S8, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, j, SDL_AudioCVT::len_mult, SDL_BuildAudioCVT, SDL_GetError, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_LogError(), SDLTest_RandomIntegerInRange(), and TEST_COMPLETED.

{
int result;
SDL_AudioCVT cvt;
SDL_AudioSpec spec1;
SDL_AudioSpec spec2;
int i, ii, j, jj, k, kk;
/* No conversion needed */
spec1.format = AUDIO_S16LSB;
spec1.channels = 2;
spec1.freq = 22050;
result = SDL_BuildAudioCVT(&cvt, spec1.format, spec1.channels, spec1.freq,
spec1.format, spec1.channels, spec1.freq);
SDLTest_AssertPass("Call to SDL_BuildAudioCVT(spec1 ==> spec1)");
SDLTest_AssertCheck(result == 0, "Verify result value; expected: 0, got: %i", result);
/* Typical conversion */
spec1.format = AUDIO_S8;
spec1.channels = 1;
spec1.freq = 22050;
spec2.format = AUDIO_S16LSB;
spec2.channels = 2;
spec2.freq = 44100;
result = SDL_BuildAudioCVT(&cvt, spec1.format, spec1.channels, spec1.freq,
spec2.format, spec2.channels, spec2.freq);
SDLTest_AssertPass("Call to SDL_BuildAudioCVT(spec1 ==> spec2)");
SDLTest_AssertCheck(result == 1, "Verify result value; expected: 1, got: %i", result);
/* All source conversions with random conversion targets, allow 'null' conversions */
for (i = 0; i < _numAudioFormats; i++) {
for (j = 0; j < _numAudioChannels; j++) {
for (k = 0; k < _numAudioFrequencies; k++) {
spec1.format = _audioFormats[i];
spec1.channels = _audioChannels[j];
spec1.freq = _audioFrequencies[k];
ii = SDLTest_RandomIntegerInRange(0, _numAudioFormats - 1);
jj = SDLTest_RandomIntegerInRange(0, _numAudioChannels - 1);
kk = SDLTest_RandomIntegerInRange(0, _numAudioFrequencies - 1);
spec2.format = _audioFormats[ii];
spec2.channels = _audioChannels[jj];
spec2.freq = _audioFrequencies[kk];
result = SDL_BuildAudioCVT(&cvt, spec1.format, spec1.channels, spec1.freq,
spec2.format, spec2.channels, spec2.freq);
SDLTest_AssertPass("Call to SDL_BuildAudioCVT(format[%i]=%s(%i),channels[%i]=%i,freq[%i]=%i ==> format[%i]=%s(%i),channels[%i]=%i,freq[%i]=%i)",
i, _audioFormatsVerbose[i], spec1.format, j, spec1.channels, k, spec1.freq, ii, _audioFormatsVerbose[ii], spec2.format, jj, spec2.channels, kk, spec2.freq);
SDLTest_AssertCheck(result == 0 || result == 1, "Verify result value; expected: 0 or 1, got: %i", result);
if (result<0) {
SDLTest_LogError("%s", SDL_GetError());
} else {
SDLTest_AssertCheck(cvt.len_mult > 0, "Verify that cvt.len_mult value; expected: >0, got: %i", cvt.len_mult);
}
}
}
}
return TEST_COMPLETED;
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:119
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDLTest_RandomIntegerInRange
Sint32 SDLTest_RandomIntegerInRange(Sint32 min, Sint32 max)
Definition: SDL_test_fuzzer.c:156
SDL_BuildAudioCVT
#define SDL_BuildAudioCVT
Definition: SDL_dynapi_overrides.h:94
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
_audioFormatsVerbose
char * _audioFormatsVerbose[]
Definition: testautomation_audio.c:501
_audioFrequencies
int _audioFrequencies[]
Definition: testautomation_audio.c:507
_audioFormats
SDL_AudioFormat _audioFormats[]
Definition: testautomation_audio.c:498
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioCVT::len_mult
int len_mult
Definition: SDL_audio.h:209
_numAudioFrequencies
const int _numAudioFrequencies
Definition: testautomation_audio.c:506
SDL_AudioCVT
Definition: SDL_audio.h:200
_numAudioChannels
const int _numAudioChannels
Definition: testautomation_audio.c:504
SDLTest_LogError
void SDLTest_LogError(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and the ERROR priority.
Definition: SDL_test_log.c:89
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
_audioChannels
Uint8 _audioChannels[]
Definition: testautomation_audio.c:505
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
_numAudioFormats
const int _numAudioFormats
Definition: testautomation_audio.c:497
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
AUDIO_S16LSB
#define AUDIO_S16LSB
Definition: SDL_audio.h:92
AUDIO_S8
#define AUDIO_S8
Definition: SDL_audio.h:90
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:42

int audio_buildAudioCVTNegative | ( |  | ) |

Checkes calls with invalid input to SDL_BuildAudioCVT.

See also
  https://wiki.libsdl.org/SDL_BuildAudioCVT

Definition at line 579 of file testautomation_audio.c.

References AUDIO_S16LSB, AUDIO_S8, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, NULL, SDL_BuildAudioCVT, SDL_ClearError, SDL_GetError, SDL_strcmp, SDL_strlcat, SDL_strlcpy, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_Log(), and TEST_COMPLETED.

{
const char *expectedError = "Parameter 'cvt' is invalid";
const char *error;
int result;
SDL_AudioCVT cvt;
SDL_AudioSpec spec1;
SDL_AudioSpec spec2;
int i;
char message[256];
/* Valid format */
spec1.format = AUDIO_S8;
spec1.channels = 1;
spec1.freq = 22050;
spec2.format = AUDIO_S16LSB;
spec2.channels = 2;
spec2.freq = 44100;
SDL_ClearError();
SDLTest_AssertPass("Call to SDL_ClearError()");
/* NULL input for CVT buffer */
result = SDL_BuildAudioCVT((SDL_AudioCVT *)NULL, spec1.format, spec1.channels, spec1.freq,
spec2.format, spec2.channels, spec2.freq);
SDLTest_AssertPass("Call to SDL_BuildAudioCVT(NULL,...)");
SDLTest_AssertCheck(result == -1, "Verify result value; expected: -1, got: %i", result);
error = SDL_GetError();
SDLTest_AssertPass("Call to SDL_GetError()");
SDLTest_AssertCheck(error != NULL, "Validate that error message was not NULL");
if (error != NULL) {
SDLTest_AssertCheck(SDL_strcmp(error, expectedError) == 0,
"Validate error message, expected: '%s', got: '%s'", expectedError, error);
}
/* Invalid conversions */
for (i = 1; i < 64; i++) {
/* Valid format to start with */
spec1.format = AUDIO_S8;
spec1.channels = 1;
spec1.freq = 22050;
spec2.format = AUDIO_S16LSB;
spec2.channels = 2;
spec2.freq = 44100;
SDL_ClearError();
SDLTest_AssertPass("Call to SDL_ClearError()");
/* Set various invalid format inputs */
SDL_strlcpy(message, "Invalid: ", 256);
if (i & 1) {
SDL_strlcat(message, " spec1.format", 256);
spec1.format = 0;
}
if (i & 2) {
SDL_strlcat(message, " spec1.channels", 256);
spec1.channels = 0;
}
if (i & 4) {
SDL_strlcat(message, " spec1.freq", 256);
spec1.freq = 0;
}
if (i & 8) {
SDL_strlcat(message, " spec2.format", 256);
spec2.format = 0;
}
if (i & 16) {
SDL_strlcat(message, " spec2.channels", 256);
spec2.channels = 0;
}
if (i & 32) {
SDL_strlcat(message, " spec2.freq", 256);
spec2.freq = 0;
}
SDLTest_Log("%s", message);
result = SDL_BuildAudioCVT(&cvt, spec1.format, spec1.channels, spec1.freq,
spec2.format, spec2.channels, spec2.freq);
SDLTest_AssertPass("Call to SDL_BuildAudioCVT(spec1 ==> spec2)");
SDLTest_AssertCheck(result == -1, "Verify result value; expected: -1, got: %i", result);
error = SDL_GetError();
SDLTest_AssertPass("Call to SDL_GetError()");
SDLTest_AssertCheck(error != NULL && error[0] != '\0', "Validate that error message was not NULL or empty");
}
SDL_ClearError();
SDLTest_AssertPass("Call to SDL_ClearError()");
return TEST_COMPLETED;
}
SDL_strlcpy
#define SDL_strlcpy
Definition: SDL_dynapi_overrides.h:400
SDL_ClearError
#define SDL_ClearError
Definition: SDL_dynapi_overrides.h:120
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:119
SDL_strlcat
#define SDL_strlcat
Definition: SDL_dynapi_overrides.h:402
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
message
GLuint GLsizei const GLchar * message
Definition: SDL_opengl_glext.h:2483
SDL_BuildAudioCVT
#define SDL_BuildAudioCVT
Definition: SDL_dynapi_overrides.h:94
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioCVT
Definition: SDL_audio.h:200
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
AUDIO_S16LSB
#define AUDIO_S16LSB
Definition: SDL_audio.h:92
SDLTest_Log
void SDLTest_Log(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and INFO priority.
Definition: SDL_test_log.c:71
SDL_strcmp
#define SDL_strcmp
Definition: SDL_dynapi_overrides.h:423
AUDIO_S8
#define AUDIO_S8
Definition: SDL_audio.h:90

int audio_convertAudio | ( |  | ) |

Convert audio using various conversion structures.

See also
  https://wiki.libsdl.org/SDL_BuildAudioCVT
  https://wiki.libsdl.org/SDL_ConvertAudio

Definition at line 817 of file testautomation_audio.c.

References _audioChannels, _audioFormats, _audioFormatsVerbose, _audioFrequencies, _numAudioChannels, _numAudioFormats, _numAudioFrequencies, SDL_AudioCVT::buf, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, j, SDL_AudioCVT::len, SDL_AudioCVT::len_mult, SDL_AudioCVT::len_ratio, NULL, SDL_BuildAudioCVT, SDL_ConvertAudio, SDL_free(), SDL_GetError, SDL_malloc, SDL_strlcat, SDL_strlcpy, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_Log(), SDLTest_LogError(), SDLTest_RandomIntegerInRange(), TEST_ABORTED, and TEST_COMPLETED.

{
int result;
SDL_AudioCVT cvt;
SDL_AudioSpec spec1;
SDL_AudioSpec spec2;
int c;
char message[128];
int i, ii, j, jj, k, kk, l, ll;
/* Iterate over bitmask that determines which parameters are modified in the conversion */
for (c = 1; c < 8; c++) {
SDL_strlcpy(message, "Changing:", 128);
if (c & 1) {
SDL_strlcat(message, " Format", 128);
}
if (c & 2) {
SDL_strlcat(message, " Channels", 128);
}
if (c & 4) {
SDL_strlcat(message, " Frequencies", 128);
}
SDLTest_Log("%s", message);
/* All source conversions with random conversion targets */
for (i = 0; i < _numAudioFormats; i++) {
for (j = 0; j < _numAudioChannels; j++) {
for (k = 0; k < _numAudioFrequencies; k++) {
spec1.format = _audioFormats[i];
spec1.channels = _audioChannels[j];
spec1.freq = _audioFrequencies[k];
/* Ensure we have a different target format */
do {
if (c & 1) {
ii = SDLTest_RandomIntegerInRange(0, _numAudioFormats - 1);
} else {
ii = 1;
}
if (c & 2) {
jj = SDLTest_RandomIntegerInRange(0, _numAudioChannels - 1);
} else {
jj= j;
}
if (c & 4) {
kk = SDLTest_RandomIntegerInRange(0, _numAudioFrequencies - 1);
} else {
kk = k;
}
} while ((i == ii) && (j == jj) && (k == kk));
spec2.format = _audioFormats[ii];
spec2.channels = _audioChannels[jj];
spec2.freq = _audioFrequencies[kk];
result = SDL_BuildAudioCVT(&cvt, spec1.format, spec1.channels, spec1.freq,
spec2.format, spec2.channels, spec2.freq);
SDLTest_AssertPass("Call to SDL_BuildAudioCVT(format[%i]=%s(%i),channels[%i]=%i,freq[%i]=%i ==> format[%i]=%s(%i),channels[%i]=%i,freq[%i]=%i)",
i, _audioFormatsVerbose[i], spec1.format, j, spec1.channels, k, spec1.freq, ii, _audioFormatsVerbose[ii], spec2.format, jj, spec2.channels, kk, spec2.freq);
SDLTest_AssertCheck(result == 1, "Verify result value; expected: 1, got: %i", result);
if (result != 1) {
SDLTest_LogError("%s", SDL_GetError());
} else {
SDLTest_AssertCheck(cvt.len_mult > 0, "Verify that cvt.len_mult value; expected: >0, got: %i", cvt.len_mult);
if (cvt.len_mult < 1) return TEST_ABORTED;
/* Create some random data to convert */
l = 64;
ll = l * cvt.len_mult;
SDLTest_Log("Creating dummy sample buffer of %i length (%i bytes)", l, ll);
cvt.len = l;
cvt.buf = (Uint8 *)SDL_malloc(ll);
SDLTest_AssertCheck(cvt.buf != NULL, "Check data buffer to convert is not NULL");
if (cvt.buf == NULL) return TEST_ABORTED;
/* Convert the data */
result = SDL_ConvertAudio(&cvt);
SDLTest_AssertPass("Call to SDL_ConvertAudio()");
SDLTest_AssertCheck(result == 0, "Verify result value; expected: 0; got: %i", result);
SDLTest_AssertCheck(cvt.buf != NULL, "Verify conversion buffer is not NULL");
SDLTest_AssertCheck(cvt.len_ratio > 0.0, "Verify conversion length ratio; expected: >0; got: %f", cvt.len_ratio);
/* Free converted buffer */
SDL_free(cvt.buf);
cvt.buf = NULL;
}
}
}
}
}
return TEST_COMPLETED;
}
SDL_strlcpy
#define SDL_strlcpy
Definition: SDL_dynapi_overrides.h:400
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:119
TEST_ABORTED
#define TEST_ABORTED
Definition: SDL_test_harness.h:51
SDL_AudioCVT::len
int len
Definition: SDL_audio.h:207
SDL_strlcat
#define SDL_strlcat
Definition: SDL_dynapi_overrides.h:402
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
message
GLuint GLsizei const GLchar * message
Definition: SDL_opengl_glext.h:2483
SDLTest_RandomIntegerInRange
Sint32 SDLTest_RandomIntegerInRange(Sint32 min, Sint32 max)
Definition: SDL_test_fuzzer.c:156
SDL_AudioCVT::buf
Uint8 * buf
Definition: SDL_audio.h:206
SDL_BuildAudioCVT
#define SDL_BuildAudioCVT
Definition: SDL_dynapi_overrides.h:94
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
_audioFormatsVerbose
char * _audioFormatsVerbose[]
Definition: testautomation_audio.c:501
_audioFrequencies
int _audioFrequencies[]
Definition: testautomation_audio.c:507
_audioFormats
SDL_AudioFormat _audioFormats[]
Definition: testautomation_audio.c:498
SDL_AudioCVT::len_ratio
double len_ratio
Definition: SDL_audio.h:210
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioCVT::len_mult
int len_mult
Definition: SDL_audio.h:209
_numAudioFrequencies
const int _numAudioFrequencies
Definition: testautomation_audio.c:506
SDL_AudioCVT
Definition: SDL_audio.h:200
_numAudioChannels
const int _numAudioChannels
Definition: testautomation_audio.c:504
SDLTest_LogError
void SDLTest_LogError(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and the ERROR priority.
Definition: SDL_test_log.c:89
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
SDL_ConvertAudio
#define SDL_ConvertAudio
Definition: SDL_dynapi_overrides.h:95
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
Uint8
uint8_t Uint8
An unsigned 8-bit integer type.
Definition: SDL_stdinc.h:139
SDL_free
void SDL_free(void *mem)
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
_audioChannels
Uint8 _audioChannels[]
Definition: testautomation_audio.c:505
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
_numAudioFormats
const int _numAudioFormats
Definition: testautomation_audio.c:497
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
SDLTest_Log
void SDLTest_Log(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and INFO priority.
Definition: SDL_test_log.c:71
SDL_malloc
#define SDL_malloc
Definition: SDL_dynapi_overrides.h:380
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:42

int audio_enumerateAndNameAudioDevices | ( |  | ) |

Enumerate and name available audio devices (output and capture).

See also
  https://wiki.libsdl.org/SDL_GetNumAudioDevices
  https://wiki.libsdl.org/SDL_GetAudioDeviceName

Definition at line 346 of file testautomation_audio.c.

References i, NULL, SDL_GetAudioDeviceName, SDL_GetNumAudioDevices, SDL_strcmp, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_Log(), SDLTest_RandomIntegerInRange(), and TEST_COMPLETED.

{
int t, tt;
int i, n, nn;
const char *name, *nameAgain;
/* Iterate over types: t=0 output device, t=1 input/capture device */
for (t=0; t<2; t++) {
/* Get number of devices. */
n = SDL_GetNumAudioDevices(t);
SDLTest_AssertPass("Call to SDL_GetNumAudioDevices(%i)", t);
SDLTest_Log("Number of %s devices < 0, reported as %i", (t) ? "capture" : "output", n);
SDLTest_AssertCheck(n >= 0, "Validate result is >= 0, got: %i", n);
/* Variation of non-zero type */
if (t==1) {
tt = t + SDLTest_RandomIntegerInRange(1,10);
nn = SDL_GetNumAudioDevices(tt);
SDLTest_AssertCheck(n==nn, "Verify result from SDL_GetNumAudioDevices(%i), expected same number of audio devices %i, got %i", tt, n, nn);
nn = SDL_GetNumAudioDevices(-tt);
SDLTest_AssertCheck(n==nn, "Verify result from SDL_GetNumAudioDevices(%i), expected same number of audio devices %i, got %i", -tt, n, nn);
}
/* List devices. */
if (n>0) {
for (i=0; i<n; i++) {
name = SDL_GetAudioDeviceName(i, t);
SDLTest_AssertPass("Call to SDL_GetAudioDeviceName(%i, %i)", i, t);
SDLTest_AssertCheck(name != NULL, "Verify result from SDL_GetAudioDeviceName(%i, %i) is not NULL", i, t);
if (name != NULL) {
SDLTest_AssertCheck(name[0] != '\0', "verify result from SDL_GetAudioDeviceName(%i, %i) is not empty, got: '%s'", i, t, name);
if (t==1) {
/* Also try non-zero type */
tt = t + SDLTest_RandomIntegerInRange(1,10);
nameAgain = SDL_GetAudioDeviceName(i, tt);
SDLTest_AssertCheck(nameAgain != NULL, "Verify result from SDL_GetAudioDeviceName(%i, %i) is not NULL", i, tt);
if (nameAgain != NULL) {
SDLTest_AssertCheck(nameAgain[0] != '\0', "Verify result from SDL_GetAudioDeviceName(%i, %i) is not empty, got: '%s'", i, tt, nameAgain);
SDLTest_AssertCheck(SDL_strcmp(name, nameAgain)==0,
"Verify SDL_GetAudioDeviceName(%i, %i) and SDL_GetAudioDeviceName(%i %i) return the same string",
i, t, i, tt);
}
}
}
}
}
}
return TEST_COMPLETED;
}
SDL_GetNumAudioDevices
#define SDL_GetNumAudioDevices
Definition: SDL_dynapi_overrides.h:85
n
GLdouble n
Definition: SDL_opengl_glext.h:1952
SDLTest_RandomIntegerInRange
Sint32 SDLTest_RandomIntegerInRange(Sint32 min, Sint32 max)
Definition: SDL_test_fuzzer.c:156
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDL_GetAudioDeviceName
#define SDL_GetAudioDeviceName
Definition: SDL_dynapi_overrides.h:86
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDLTest_Log
void SDLTest_Log(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and INFO priority.
Definition: SDL_test_log.c:71
SDL_strcmp
#define SDL_strcmp
Definition: SDL_dynapi_overrides.h:423
t
GLdouble GLdouble t
Definition: SDL_opengl.h:2064

int audio_enumerateAndNameAudioDevicesNegativeTests | ( |  | ) |

Negative tests around enumeration and naming of audio devices.

See also
  https://wiki.libsdl.org/SDL_GetNumAudioDevices
  https://wiki.libsdl.org/SDL_GetAudioDeviceName

Definition at line 404 of file testautomation_audio.c.

References i, j, NULL, SDL_GetAudioDeviceName, SDL_GetNumAudioDevices, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_RandomIntegerInRange(), and TEST_COMPLETED.

{
int t;
int i, j, no, nc;
const char *name;
/* Get number of devices. */
no = SDL_GetNumAudioDevices(0);
SDLTest_AssertPass("Call to SDL_GetNumAudioDevices(0)");
nc = SDL_GetNumAudioDevices(1);
SDLTest_AssertPass("Call to SDL_GetNumAudioDevices(1)");
/* Invalid device index when getting name */
for (t=0; t<2; t++) {
/* Negative device index */
i = SDLTest_RandomIntegerInRange(-10,-1);
name = SDL_GetAudioDeviceName(i, t);
SDLTest_AssertPass("Call to SDL_GetAudioDeviceName(%i, %i)", i, t);
SDLTest_AssertCheck(name == NULL, "Check SDL_GetAudioDeviceName(%i, %i) result NULL, expected NULL, got: %s", i, t, (name == NULL) ? "NULL" : name);
/* Device index past range */
for (j=0; j<3; j++) {
i = (t) ? nc+j : no+j;
name = SDL_GetAudioDeviceName(i, t);
SDLTest_AssertPass("Call to SDL_GetAudioDeviceName(%i, %i)", i, t);
SDLTest_AssertCheck(name == NULL, "Check SDL_GetAudioDeviceName(%i, %i) result, expected: NULL, got: %s", i, t, (name == NULL) ? "NULL" : name);
}
/* Capture index past capture range but within output range */
if ((no>0) && (no>nc) && (t==1)) {
i = no-1;
name = SDL_GetAudioDeviceName(i, t);
SDLTest_AssertPass("Call to SDL_GetAudioDeviceName(%i, %i)", i, t);
SDLTest_AssertCheck(name == NULL, "Check SDL_GetAudioDeviceName(%i, %i) result, expected: NULL, got: %s", i, t, (name == NULL) ? "NULL" : name);
}
}
return TEST_COMPLETED;
}
SDL_GetNumAudioDevices
#define SDL_GetNumAudioDevices
Definition: SDL_dynapi_overrides.h:85
SDLTest_RandomIntegerInRange
Sint32 SDLTest_RandomIntegerInRange(Sint32 min, Sint32 max)
Definition: SDL_test_fuzzer.c:156
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDL_GetAudioDeviceName
#define SDL_GetAudioDeviceName
Definition: SDL_dynapi_overrides.h:86
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
t
GLdouble GLdouble t
Definition: SDL_opengl.h:2064
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:42

int audio_getAudioStatus | ( |  | ) |

Checks current audio status.

See also
  https://wiki.libsdl.org/SDL_GetAudioStatus

Definition at line 674 of file testautomation_audio.c.

References SDL_AUDIO_PAUSED, SDL_AUDIO_PLAYING, SDL_AUDIO_STOPPED, SDL_GetAudioStatus, SDLTest_AssertCheck(), SDLTest_AssertPass(), and TEST_COMPLETED.

{
SDL_AudioStatus result;
/* Check current audio status */
result = SDL_GetAudioStatus();
SDLTest_AssertPass("Call to SDL_GetAudioStatus()");
SDLTest_AssertCheck(result == SDL_AUDIO_STOPPED || result == SDL_AUDIO_PLAYING || result == SDL_AUDIO_PAUSED,
"Verify returned value; expected: STOPPED (%i) | PLAYING (%i) | PAUSED (%i), got: %i",
SDL_AUDIO_STOPPED, SDL_AUDIO_PLAYING, SDL_AUDIO_PAUSED, result);
return TEST_COMPLETED;
}
SDL_GetAudioStatus
#define SDL_GetAudioStatus
Definition: SDL_dynapi_overrides.h:88
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_AudioStatus
SDL_AudioStatus
Definition: SDL_audio.h:368
SDL_AUDIO_PAUSED
Definition: SDL_audio.h:372
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_AUDIO_STOPPED
Definition: SDL_audio.h:370
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_AUDIO_PLAYING
Definition: SDL_audio.h:371

int audio_initOpenCloseQuitAudio | ( |  | ) |

Start, open, close and stop audio.

See also
  https://wiki.libsdl.org/SDL_InitAudio
  https://wiki.libsdl.org/SDL_OpenAudio
  https://wiki.libsdl.org/SDL_CloseAudio
  https://wiki.libsdl.org/SDL_QuitAudio

Definition at line 139 of file testautomation_audio.c.

References _audio_testCallback(), _audioSetUp(), AUDIO_F32SYS, AUDIO_S16SYS, SDL_AudioSpec::callback, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, j, NULL, SDL_AudioSpec::samples, SDL_AudioInit, SDL_AudioQuit, SDL_CloseAudio, SDL_GetAudioDriver, SDL_GetNumAudioDrivers, SDL_INIT_AUDIO, SDL_memset, SDL_OpenAudio, SDL_QuitSubSystem, SDLTest_AssertCheck(), SDLTest_AssertPass(), TEST_COMPLETED, and SDL_AudioSpec::userdata.

{
int result, expectedResult;
int i, iMax, j, k;
const char* audioDriver;
SDL_AudioSpec desired;
/* Stop SDL audio subsystem */
SDL_QuitSubSystem( SDL_INIT_AUDIO );
SDLTest_AssertPass("Call to SDL_QuitSubSystem(SDL_INIT_AUDIO)");
/* Loop over all available audio drivers */
iMax = SDL_GetNumAudioDrivers();
SDLTest_AssertPass("Call to SDL_GetNumAudioDrivers()");
SDLTest_AssertCheck(iMax > 0, "Validate number of audio drivers; expected: >0 got: %d", iMax);
for (i = 0; i < iMax; i++) {
audioDriver = SDL_GetAudioDriver(i);
SDLTest_AssertPass("Call to SDL_GetAudioDriver(%d)", i);
SDLTest_AssertCheck(audioDriver != NULL, "Audio driver name is not NULL");
SDLTest_AssertCheck(audioDriver[0] != '\0', "Audio driver name is not empty; got: %s", audioDriver);
/* Change specs */
for (j = 0; j < 2; j++) {
/* Call Init */
result = SDL_AudioInit(audioDriver);
SDLTest_AssertPass("Call to SDL_AudioInit('%s')", audioDriver);
SDLTest_AssertCheck(result == 0, "Validate result value; expected: 0 got: %d", result);
/* Set spec */
SDL_memset(&desired, 0, sizeof(desired));
switch (j) {
case 0:
/* Set standard desired spec */
desired.freq = 22050;
desired.format = AUDIO_S16SYS;
desired.channels = 2;
desired.samples = 4096;
desired.callback = _audio_testCallback;
desired.userdata = NULL;
case 1:
/* Set custom desired spec */
desired.freq = 48000;
desired.format = AUDIO_F32SYS;
desired.channels = 2;
desired.samples = 2048;
desired.callback = _audio_testCallback;
desired.userdata = NULL;
break;
}
/* Call Open (maybe multiple times) */
for (k=0; k <= j; k++) {
result = SDL_OpenAudio(&desired, NULL);
SDLTest_AssertPass("Call to SDL_OpenAudio(desired_spec_%d, NULL), call %d", j, k+1);
expectedResult = (k==0) ? 0 : -1;
SDLTest_AssertCheck(result == expectedResult, "Verify return value; expected: %d, got: %d", expectedResult, result);
}
/* Call Close (maybe multiple times) */
for (k=0; k <= j; k++) {
SDL_CloseAudio();
SDLTest_AssertPass("Call to SDL_CloseAudio(), call %d", k+1);
}
/* Call Quit (maybe multiple times) */
for (k=0; k <= j; k++) {
SDL_AudioQuit();
SDLTest_AssertPass("Call to SDL_AudioQuit(), call %d", k+1);
}
} /* spec loop */
} /* driver loop */
/* Restart audio again */
_audioSetUp(NULL);
return TEST_COMPLETED;
}
SDL_GetNumAudioDrivers
#define SDL_GetNumAudioDrivers
Definition: SDL_dynapi_overrides.h:79
SDL_OpenAudio
#define SDL_OpenAudio
Definition: SDL_dynapi_overrides.h:84
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDL_AudioInit
#define SDL_AudioInit
Definition: SDL_dynapi_overrides.h:81
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:62
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioSpec::samples
Uint16 samples
Definition: SDL_audio.h:174
AUDIO_S16SYS
#define AUDIO_S16SYS
Definition: SDL_audio.h:123
SDL_AudioQuit
#define SDL_AudioQuit
Definition: SDL_dynapi_overrides.h:82
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
AUDIO_F32SYS
#define AUDIO_F32SYS
Definition: SDL_audio.h:125
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_GetAudioDriver
#define SDL_GetAudioDriver
Definition: SDL_dynapi_overrides.h:80
SDL_AudioSpec::callback
SDL_AudioCallback callback
Definition: SDL_audio.h:177
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_INIT_AUDIO
#define SDL_INIT_AUDIO
Definition: SDL.h:76
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
SDL_CloseAudio
#define SDL_CloseAudio
Definition: SDL_dynapi_overrides.h:102
SDL_AudioSpec::userdata
void * userdata
Definition: SDL_audio.h:178
_audio_testCallback
void _audio_testCallback(void *userdata, Uint8 *stream, int len)
Definition: testautomation_audio.c:49
_audioSetUp
void _audioSetUp(void *arg)
Definition: testautomation_audio.c:20
SDL_memset
#define SDL_memset
Definition: SDL_dynapi_overrides.h:392
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:42

int audio_initQuitAudio | ( |  | ) |

Start and stop audio directly.

See also
  https://wiki.libsdl.org/SDL_InitAudio
  https://wiki.libsdl.org/SDL_QuitAudio

Definition at line 83 of file testautomation_audio.c.

References _audioSetUp(), i, NULL, SDL_AudioInit, SDL_AudioQuit, SDL_GetAudioDriver, SDL_GetNumAudioDrivers, SDL_INIT_AUDIO, SDL_QuitSubSystem, SDLTest_AssertCheck(), SDLTest_AssertPass(), and TEST_COMPLETED.

{
int result;
int i, iMax;
const char* audioDriver;
/* Stop SDL audio subsystem */
SDL_QuitSubSystem( SDL_INIT_AUDIO );
SDLTest_AssertPass("Call to SDL_QuitSubSystem(SDL_INIT_AUDIO)");
/* Loop over all available audio drivers */
iMax = SDL_GetNumAudioDrivers();
SDLTest_AssertPass("Call to SDL_GetNumAudioDrivers()");
SDLTest_AssertCheck(iMax > 0, "Validate number of audio drivers; expected: >0 got: %d", iMax);
for (i = 0; i < iMax; i++) {
audioDriver = SDL_GetAudioDriver(i);
SDLTest_AssertPass("Call to SDL_GetAudioDriver(%d)", i);
SDLTest_AssertCheck(audioDriver != NULL, "Audio driver name is not NULL");
SDLTest_AssertCheck(audioDriver[0] != '\0', "Audio driver name is not empty; got: %s", audioDriver);
/* Call Init */
result = SDL_AudioInit(audioDriver);
SDLTest_AssertPass("Call to SDL_AudioInit('%s')", audioDriver);
SDLTest_AssertCheck(result == 0, "Validate result value; expected: 0 got: %d", result);
/* Call Quit */
SDL_AudioQuit();
SDLTest_AssertPass("Call to SDL_AudioQuit()");
}
/* NULL driver specification */
audioDriver = NULL;
/* Call Init */
result = SDL_AudioInit(audioDriver);
SDLTest_AssertPass("Call to SDL_AudioInit(NULL)");
SDLTest_AssertCheck(result == 0, "Validate result value; expected: 0 got: %d", result);
/* Call Quit */
SDL_AudioQuit();
SDLTest_AssertPass("Call to SDL_AudioQuit()");
/* Restart audio again */
_audioSetUp(NULL);
return TEST_COMPLETED;
}
SDL_GetNumAudioDrivers
#define SDL_GetNumAudioDrivers
Definition: SDL_dynapi_overrides.h:79
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDL_AudioInit
#define SDL_AudioInit
Definition: SDL_dynapi_overrides.h:81
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:62
SDL_AudioQuit
#define SDL_AudioQuit
Definition: SDL_dynapi_overrides.h:82
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_GetAudioDriver
#define SDL_GetAudioDriver
Definition: SDL_dynapi_overrides.h:80
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_INIT_AUDIO
#define SDL_INIT_AUDIO
Definition: SDL.h:76
_audioSetUp
void _audioSetUp(void *arg)
Definition: testautomation_audio.c:20

int audio_lockUnlockOpenAudioDevice | ( |  | ) |

Locks and unlocks open audio device.

See also
  https://wiki.libsdl.org/SDL_LockAudioDevice
  https://wiki.libsdl.org/SDL_UnlockAudioDevice

Definition at line 754 of file testautomation_audio.c.

References _audio_testCallback(), AUDIO_S16SYS, SDL_AudioSpec::callback, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, NULL, SDL_AudioSpec::samples, SDL_AUDIO_ALLOW_ANY_CHANGE, SDL_CloseAudioDevice, SDL_Delay, SDL_GetAudioDeviceName, SDL_GetNumAudioDevices, SDL_LockAudioDevice, SDL_OpenAudioDevice, SDL_UnlockAudioDevice, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_Log(), TEST_ABORTED, TEST_COMPLETED, and SDL_AudioSpec::userdata.

{
int i;
int count;
char *device;
SDL_AudioDeviceID id;
SDL_AudioSpec desired, obtained;
/* Get number of devices. */
count = SDL_GetNumAudioDevices(0);
SDLTest_AssertPass("Call to SDL_GetNumAudioDevices(0)");
if (count > 0) {
for (i = 0; i < count; i++) {
/* Get device name */
device = (char *)SDL_GetAudioDeviceName(i, 0);
SDLTest_AssertPass("SDL_GetAudioDeviceName(%i,0)", i);
SDLTest_AssertCheck(device != NULL, "Validate device name is not NULL; got: %s", (device != NULL) ? device : "NULL");
if (device == NULL) return TEST_ABORTED;
/* Set standard desired spec */
desired.freq=22050;
desired.format=AUDIO_S16SYS;
desired.channels=2;
desired.samples=4096;
desired.callback=_audio_testCallback;
desired.userdata=NULL;
/* Open device */
id = SDL_OpenAudioDevice((const char *)device, 0, &desired, &obtained, SDL_AUDIO_ALLOW_ANY_CHANGE);
SDLTest_AssertPass("SDL_OpenAudioDevice('%s',...)", device);
SDLTest_AssertCheck(id > 1, "Validate device ID; expected: >=2, got: %i", id);
if (id > 1) {
/* Lock to protect callback */
SDL_LockAudioDevice(id);
SDLTest_AssertPass("SDL_LockAudioDevice(%i)", id);
/* Simulate callback processing */
SDL_Delay(10);
SDLTest_Log("Simulate callback processing - delay");
/* Unlock again */
SDL_UnlockAudioDevice(id);
SDLTest_AssertPass("SDL_UnlockAudioDevice(%i)", id);
/* Close device again */
SDL_CloseAudioDevice(id);
SDLTest_AssertPass("Call to SDL_CloseAudioDevice()");
}
}
} else {
SDLTest_Log("No devices to test with");
}
return TEST_COMPLETED;
}
SDL_GetNumAudioDevices
#define SDL_GetNumAudioDevices
Definition: SDL_dynapi_overrides.h:85
id
GLuint id
Definition: SDL_opengl_glext.h:528
SDL_CloseAudioDevice
#define SDL_CloseAudioDevice
Definition: SDL_dynapi_overrides.h:103
TEST_ABORTED
#define TEST_ABORTED
Definition: SDL_test_harness.h:51
SDL_OpenAudioDevice
#define SDL_OpenAudioDevice
Definition: SDL_dynapi_overrides.h:87
count
GLuint GLuint GLsizei count
Definition: SDL_opengl.h:1564
SDL_LockAudioDevice
#define SDL_LockAudioDevice
Definition: SDL_dynapi_overrides.h:99
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioSpec::samples
Uint16 samples
Definition: SDL_audio.h:174
AUDIO_S16SYS
#define AUDIO_S16SYS
Definition: SDL_audio.h:123
SDL_GetAudioDeviceName
#define SDL_GetAudioDeviceName
Definition: SDL_dynapi_overrides.h:86
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_AUDIO_ALLOW_ANY_CHANGE
#define SDL_AUDIO_ALLOW_ANY_CHANGE
Definition: SDL_audio.h:143
SDL_AudioSpec::callback
SDL_AudioCallback callback
Definition: SDL_audio.h:177
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:490
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_AudioDeviceID
Uint32 SDL_AudioDeviceID
Definition: SDL_audio.h:303
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
SDL_AudioSpec::userdata
void * userdata
Definition: SDL_audio.h:178
SDLTest_Log
void SDLTest_Log(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and INFO priority.
Definition: SDL_test_log.c:71
_audio_testCallback
void _audio_testCallback(void *userdata, Uint8 *stream, int len)
Definition: testautomation_audio.c:49
SDL_UnlockAudioDevice
#define SDL_UnlockAudioDevice
Definition: SDL_dynapi_overrides.h:101

int audio_openCloseAndGetAudioStatus | ( |  | ) |

Opens, checks current audio status, and closes a device.

See also
  https://wiki.libsdl.org/SDL_GetAudioStatus

Definition at line 695 of file testautomation_audio.c.

References _audio_testCallback(), AUDIO_S16SYS, SDL_AudioSpec::callback, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, NULL, SDL_AudioSpec::samples, SDL_AUDIO_ALLOW_ANY_CHANGE, SDL_AUDIO_PAUSED, SDL_AUDIO_PLAYING, SDL_AUDIO_STOPPED, SDL_CloseAudioDevice, SDL_GetAudioDeviceName, SDL_GetAudioDeviceStatus, SDL_GetNumAudioDevices, SDL_OpenAudioDevice, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_Log(), TEST_ABORTED, TEST_COMPLETED, and SDL_AudioSpec::userdata.

{
SDL_AudioStatus result;
int i;
int count;
char *device;
SDL_AudioDeviceID id;
SDL_AudioSpec desired, obtained;
/* Get number of devices. */
count = SDL_GetNumAudioDevices(0);
SDLTest_AssertPass("Call to SDL_GetNumAudioDevices(0)");
if (count > 0) {
for (i = 0; i < count; i++) {
/* Get device name */
device = (char *)SDL_GetAudioDeviceName(i, 0);
SDLTest_AssertPass("SDL_GetAudioDeviceName(%i,0)", i);
SDLTest_AssertCheck(device != NULL, "Validate device name is not NULL; got: %s", (device != NULL) ? device : "NULL");
if (device == NULL) return TEST_ABORTED;
/* Set standard desired spec */
desired.freq=22050;
desired.format=AUDIO_S16SYS;
desired.channels=2;
desired.samples=4096;
desired.callback=_audio_testCallback;
desired.userdata=NULL;
/* Open device */
id = SDL_OpenAudioDevice((const char *)device, 0, &desired, &obtained, SDL_AUDIO_ALLOW_ANY_CHANGE);
SDLTest_AssertPass("SDL_OpenAudioDevice('%s',...)", device);
SDLTest_AssertCheck(id > 1, "Validate device ID; expected: >=2, got: %i", id);
if (id > 1) {
/* Check device audio status */
result = SDL_GetAudioDeviceStatus(id);
SDLTest_AssertPass("Call to SDL_GetAudioDeviceStatus()");
SDLTest_AssertCheck(result == SDL_AUDIO_STOPPED || result == SDL_AUDIO_PLAYING || result == SDL_AUDIO_PAUSED,
"Verify returned value; expected: STOPPED (%i) | PLAYING (%i) | PAUSED (%i), got: %i",
SDL_AUDIO_STOPPED, SDL_AUDIO_PLAYING, SDL_AUDIO_PAUSED, result);
/* Close device again */
SDL_CloseAudioDevice(id);
SDLTest_AssertPass("Call to SDL_CloseAudioDevice()");
}
}
} else {
SDLTest_Log("No devices to test with");
}
return TEST_COMPLETED;
}
SDL_GetNumAudioDevices
#define SDL_GetNumAudioDevices
Definition: SDL_dynapi_overrides.h:85
id
GLuint id
Definition: SDL_opengl_glext.h:528
SDL_CloseAudioDevice
#define SDL_CloseAudioDevice
Definition: SDL_dynapi_overrides.h:103
TEST_ABORTED
#define TEST_ABORTED
Definition: SDL_test_harness.h:51
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDL_OpenAudioDevice
#define SDL_OpenAudioDevice
Definition: SDL_dynapi_overrides.h:87
count
GLuint GLuint GLsizei count
Definition: SDL_opengl.h:1564
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_AudioStatus
SDL_AudioStatus
Definition: SDL_audio.h:368
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioSpec::samples
Uint16 samples
Definition: SDL_audio.h:174
SDL_AUDIO_PAUSED
Definition: SDL_audio.h:372
AUDIO_S16SYS
#define AUDIO_S16SYS
Definition: SDL_audio.h:123
SDL_GetAudioDeviceName
#define SDL_GetAudioDeviceName
Definition: SDL_dynapi_overrides.h:86
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_AUDIO_ALLOW_ANY_CHANGE
#define SDL_AUDIO_ALLOW_ANY_CHANGE
Definition: SDL_audio.h:143
SDL_AUDIO_STOPPED
Definition: SDL_audio.h:370
SDL_GetAudioDeviceStatus
#define SDL_GetAudioDeviceStatus
Definition: SDL_dynapi_overrides.h:89
SDL_AudioSpec::callback
SDL_AudioCallback callback
Definition: SDL_audio.h:177
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_AudioDeviceID
Uint32 SDL_AudioDeviceID
Definition: SDL_audio.h:303
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
SDL_AudioSpec::userdata
void * userdata
Definition: SDL_audio.h:178
SDLTest_Log
void SDLTest_Log(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and INFO priority.
Definition: SDL_test_log.c:71
_audio_testCallback
void _audio_testCallback(void *userdata, Uint8 *stream, int len)
Definition: testautomation_audio.c:49
SDL_AUDIO_PLAYING
Definition: SDL_audio.h:371

int audio_openCloseAudioDeviceConnected | ( |  | ) |

Opens, checks current connected status, and closes a device.

See also
  https://wiki.libsdl.org/SDL_AudioDeviceConnected

Definition at line 915 of file testautomation_audio.c.

References _audio_testCallback(), AUDIO_S16SYS, SDL_AudioSpec::callback, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, NULL, SDL_AudioSpec::samples, SDL_AUDIO_ALLOW_ANY_CHANGE, SDL_CloseAudioDevice, SDL_GetAudioDeviceName, SDL_GetNumAudioDevices, SDL_OpenAudioDevice, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_Log(), TEST_ABORTED, TEST_COMPLETED, and SDL_AudioSpec::userdata.

{
int result = -1;
int i;
int count;
char *device;
SDL_AudioDeviceID id;
SDL_AudioSpec desired, obtained;
/* Get number of devices. */
count = SDL_GetNumAudioDevices(0);
SDLTest_AssertPass("Call to SDL_GetNumAudioDevices(0)");
if (count > 0) {
for (i = 0; i < count; i++) {
/* Get device name */
device = (char *)SDL_GetAudioDeviceName(i, 0);
SDLTest_AssertPass("SDL_GetAudioDeviceName(%i,0)", i);
SDLTest_AssertCheck(device != NULL, "Validate device name is not NULL; got: %s", (device != NULL) ? device : "NULL");
if (device == NULL) return TEST_ABORTED;
/* Set standard desired spec */
desired.freq=22050;
desired.format=AUDIO_S16SYS;
desired.channels=2;
desired.samples=4096;
desired.callback=_audio_testCallback;
desired.userdata=NULL;
/* Open device */
id = SDL_OpenAudioDevice((const char *)device, 0, &desired, &obtained, SDL_AUDIO_ALLOW_ANY_CHANGE);
SDLTest_AssertPass("SDL_OpenAudioDevice('%s',...)", device);
SDLTest_AssertCheck(id > 1, "Validate device ID; expected: >1, got: %i", id);
if (id > 1) {
/* TODO: enable test code when function is available in SDL2 */
#ifdef AUDIODEVICECONNECTED_DEFINED
/* Get connected status */
result = SDL_AudioDeviceConnected(id);
SDLTest_AssertPass("Call to SDL_AudioDeviceConnected()");
#endif
SDLTest_AssertCheck(result == 1, "Verify returned value; expected: 1; got: %i", result);
/* Close device again */
SDL_CloseAudioDevice(id);
SDLTest_AssertPass("Call to SDL_CloseAudioDevice()");
}
}
} else {
SDLTest_Log("No devices to test with");
}
return TEST_COMPLETED;
}
SDL_GetNumAudioDevices
#define SDL_GetNumAudioDevices
Definition: SDL_dynapi_overrides.h:85
id
GLuint id
Definition: SDL_opengl_glext.h:528
SDL_CloseAudioDevice
#define SDL_CloseAudioDevice
Definition: SDL_dynapi_overrides.h:103
TEST_ABORTED
#define TEST_ABORTED
Definition: SDL_test_harness.h:51
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDL_OpenAudioDevice
#define SDL_OpenAudioDevice
Definition: SDL_dynapi_overrides.h:87
count
GLuint GLuint GLsizei count
Definition: SDL_opengl.h:1564
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioSpec::samples
Uint16 samples
Definition: SDL_audio.h:174
AUDIO_S16SYS
#define AUDIO_S16SYS
Definition: SDL_audio.h:123
SDL_GetAudioDeviceName
#define SDL_GetAudioDeviceName
Definition: SDL_dynapi_overrides.h:86
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_AUDIO_ALLOW_ANY_CHANGE
#define SDL_AUDIO_ALLOW_ANY_CHANGE
Definition: SDL_audio.h:143
SDL_AudioSpec::callback
SDL_AudioCallback callback
Definition: SDL_audio.h:177
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_AudioDeviceID
Uint32 SDL_AudioDeviceID
Definition: SDL_audio.h:303
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
SDL_AudioSpec::userdata
void * userdata
Definition: SDL_audio.h:178
SDLTest_Log
void SDLTest_Log(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and INFO priority.
Definition: SDL_test_log.c:71
_audio_testCallback
void _audio_testCallback(void *userdata, Uint8 *stream, int len)
Definition: testautomation_audio.c:49

int audio_pauseUnpauseAudio | ( |  | ) |

Pause and unpause audio.

See also
  https://wiki.libsdl.org/SDL_PauseAudio

Definition at line 225 of file testautomation_audio.c.

References _audio_testCallback(), _audio_testCallbackCounter, _audio_testCallbackLength, _audioSetUp(), AUDIO_F32SYS, AUDIO_S16SYS, SDL_AudioSpec::callback, SDL_AudioSpec::channels, SDL_AudioSpec::format, SDL_AudioSpec::freq, i, j, NULL, SDL_AudioSpec::samples, SDL_AudioInit, SDL_AudioQuit, SDL_CloseAudio, SDL_Delay, SDL_GetAudioDriver, SDL_GetNumAudioDrivers, SDL_INIT_AUDIO, SDL_memset, SDL_OpenAudio, SDL_PauseAudio, SDL_QuitSubSystem, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_Log(), SDLTest_RandomIntegerInRange(), TEST_COMPLETED, and SDL_AudioSpec::userdata.

{
int result;
int i, iMax, j, k, l;
int totalDelay;
int pause_on;
int originalCounter;
const char* audioDriver;
SDL_AudioSpec desired;
/* Stop SDL audio subsystem */
SDL_QuitSubSystem( SDL_INIT_AUDIO );
SDLTest_AssertPass("Call to SDL_QuitSubSystem(SDL_INIT_AUDIO)");
/* Loop over all available audio drivers */
iMax = SDL_GetNumAudioDrivers();
SDLTest_AssertPass("Call to SDL_GetNumAudioDrivers()");
SDLTest_AssertCheck(iMax > 0, "Validate number of audio drivers; expected: >0 got: %d", iMax);
for (i = 0; i < iMax; i++) {
audioDriver = SDL_GetAudioDriver(i);
SDLTest_AssertPass("Call to SDL_GetAudioDriver(%d)", i);
SDLTest_AssertCheck(audioDriver != NULL, "Audio driver name is not NULL");
SDLTest_AssertCheck(audioDriver[0] != '\0', "Audio driver name is not empty; got: %s", audioDriver);
/* Change specs */
for (j = 0; j < 2; j++) {
/* Call Init */
result = SDL_AudioInit(audioDriver);
SDLTest_AssertPass("Call to SDL_AudioInit('%s')", audioDriver);
SDLTest_AssertCheck(result == 0, "Validate result value; expected: 0 got: %d", result);
/* Set spec */
SDL_memset(&desired, 0, sizeof(desired));
switch (j) {
case 0:
/* Set standard desired spec */
desired.freq = 22050;
desired.format = AUDIO_S16SYS;
desired.channels = 2;
desired.samples = 4096;
desired.callback = _audio_testCallback;
desired.userdata = NULL;
case 1:
/* Set custom desired spec */
desired.freq = 48000;
desired.format = AUDIO_F32SYS;
desired.channels = 2;
desired.samples = 2048;
desired.callback = _audio_testCallback;
desired.userdata = NULL;
break;
}
/* Call Open */
result = SDL_OpenAudio(&desired, NULL);
SDLTest_AssertPass("Call to SDL_OpenAudio(desired_spec_%d, NULL)", j);
SDLTest_AssertCheck(result == 0, "Verify return value; expected: 0 got: %d", result);
/* Start and stop audio multiple times */
for (l=0; l<3; l++) {
SDLTest_Log("Pause/Unpause iteration: %d", l+1);
/* Reset callback counters */
_audio_testCallbackCounter = 0;
_audio_testCallbackLength = 0;
/* Un-pause audio to start playing (maybe multiple times) */
pause_on = 0;
for (k=0; k <= j; k++) {
SDL_PauseAudio(pause_on);
SDLTest_AssertPass("Call to SDL_PauseAudio(%d), call %d", pause_on, k+1);
}
/* Wait for callback */
totalDelay = 0;
do {
SDL_Delay(10);
totalDelay += 10;
}
while (_audio_testCallbackCounter == 0 && totalDelay < 1000);
SDLTest_AssertCheck(_audio_testCallbackCounter > 0, "Verify callback counter; expected: >0 got: %d", _audio_testCallbackCounter);
SDLTest_AssertCheck(_audio_testCallbackLength > 0, "Verify callback length; expected: >0 got: %d", _audio_testCallbackLength);
/* Pause audio to stop playing (maybe multiple times) */
for (k=0; k <= j; k++) {
pause_on = (k==0) ? 1 : SDLTest_RandomIntegerInRange(99, 9999);
SDL_PauseAudio(pause_on);
SDLTest_AssertPass("Call to SDL_PauseAudio(%d), call %d", pause_on, k+1);
}
/* Ensure callback is not called again */
originalCounter = _audio_testCallbackCounter;
SDL_Delay(totalDelay + 10);
SDLTest_AssertCheck(originalCounter == _audio_testCallbackCounter, "Verify callback counter; expected: %d, got: %d", originalCounter, _audio_testCallbackCounter);
}
/* Call Close */
SDL_CloseAudio();
SDLTest_AssertPass("Call to SDL_CloseAudio()");
/* Call Quit */
SDL_AudioQuit();
SDLTest_AssertPass("Call to SDL_AudioQuit()");
} /* spec loop */
} /* driver loop */
/* Restart audio again */
_audioSetUp(NULL);
return TEST_COMPLETED;
}
SDL_GetNumAudioDrivers
#define SDL_GetNumAudioDrivers
Definition: SDL_dynapi_overrides.h:79
SDL_OpenAudio
#define SDL_OpenAudio
Definition: SDL_dynapi_overrides.h:84
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDLTest_RandomIntegerInRange
Sint32 SDLTest_RandomIntegerInRange(Sint32 min, Sint32 max)
Definition: SDL_test_fuzzer.c:156
SDL_AudioInit
#define SDL_AudioInit
Definition: SDL_dynapi_overrides.h:81
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:62
SDL_AudioSpec
Definition: SDL_audio.h:168
SDL_AudioSpec::samples
Uint16 samples
Definition: SDL_audio.h:174
AUDIO_S16SYS
#define AUDIO_S16SYS
Definition: SDL_audio.h:123
SDL_AudioQuit
#define SDL_AudioQuit
Definition: SDL_dynapi_overrides.h:82
SDL_PauseAudio
#define SDL_PauseAudio
Definition: SDL_dynapi_overrides.h:90
SDL_AudioSpec::freq
int freq
Definition: SDL_audio.h:170
AUDIO_F32SYS
#define AUDIO_F32SYS
Definition: SDL_audio.h:125
SDL_AudioSpec::channels
Uint8 channels
Definition: SDL_audio.h:172
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
_audio_testCallbackLength
int _audio_testCallbackLength
Definition: testautomation_audio.c:45
SDL_GetAudioDriver
#define SDL_GetAudioDriver
Definition: SDL_dynapi_overrides.h:80
SDL_AudioSpec::callback
SDL_AudioCallback callback
Definition: SDL_audio.h:177
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:490
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143
SDL_INIT_AUDIO
#define SDL_INIT_AUDIO
Definition: SDL.h:76
SDL_AudioSpec::format
SDL_AudioFormat format
Definition: SDL_audio.h:171
SDL_CloseAudio
#define SDL_CloseAudio
Definition: SDL_dynapi_overrides.h:102
SDL_AudioSpec::userdata
void * userdata
Definition: SDL_audio.h:178
_audio_testCallbackCounter
int _audio_testCallbackCounter
Definition: testautomation_audio.c:42
SDLTest_Log
void SDLTest_Log(SDL_PRINTF_FORMAT_STRING const char *fmt,...) SDL_PRINTF_VARARG_FUNC(1)
Prints given message with a timestamp in the TEST category and INFO priority.
Definition: SDL_test_log.c:71
_audio_testCallback
void _audio_testCallback(void *userdata, Uint8 *stream, int len)
Definition: testautomation_audio.c:49
_audioSetUp
void _audioSetUp(void *arg)
Definition: testautomation_audio.c:20
SDL_memset
#define SDL_memset
Definition: SDL_dynapi_overrides.h:392
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:42

int audio_printAudioDrivers | ( |  | ) |

Checks available audio driver names.

See also
  https://wiki.libsdl.org/SDL_GetNumAudioDrivers
  https://wiki.libsdl.org/SDL_GetAudioDriver

Definition at line 451 of file testautomation_audio.c.

References i, NULL, SDL_GetAudioDriver, SDL_GetNumAudioDrivers, SDLTest_AssertCheck(), SDLTest_AssertPass(), and TEST_COMPLETED.

{
int i, n;
const char *name;
/* Get number of drivers */
n = SDL_GetNumAudioDrivers();
SDLTest_AssertPass("Call to SDL_GetNumAudioDrivers()");
SDLTest_AssertCheck(n>=0, "Verify number of audio drivers >= 0, got: %i", n);
/* List drivers. */
if (n>0)
{
for (i=0; i<n; i++) {
name = SDL_GetAudioDriver(i);
SDLTest_AssertPass("Call to SDL_GetAudioDriver(%i)", i);
SDLTest_AssertCheck(name != NULL, "Verify returned name is not NULL");
if (name != NULL) {
SDLTest_AssertCheck(name[0] != '\0', "Verify returned name is not empty, got: '%s'", name);
}
}
}
return TEST_COMPLETED;
}
SDL_GetNumAudioDrivers
#define SDL_GetNumAudioDrivers
Definition: SDL_dynapi_overrides.h:79
n
GLdouble n
Definition: SDL_opengl_glext.h:1952
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_GetAudioDriver
#define SDL_GetAudioDriver
Definition: SDL_dynapi_overrides.h:80
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
NULL
#define NULL
Definition: begin_code.h:143

int audio_printCurrentAudioDriver | ( |  | ) |

Checks current audio driver name with initialized audio.

See also
  https://wiki.libsdl.org/SDL_GetCurrentAudioDriver

Definition at line 483 of file testautomation_audio.c.

References NULL, SDL_GetCurrentAudioDriver, SDLTest_AssertCheck(), SDLTest_AssertPass(), and TEST_COMPLETED.

{
/* Check current audio driver */
const char *name = SDL_GetCurrentAudioDriver();
SDLTest_AssertPass("Call to SDL_GetCurrentAudioDriver()");
SDLTest_AssertCheck(name != NULL, "Verify returned name is not NULL");
if (name != NULL) {
SDLTest_AssertCheck(name[0] != '\0', "Verify returned name is not empty, got: '%s'", name);
}
return TEST_COMPLETED;
}
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_GetCurrentAudioDriver
#define SDL_GetCurrentAudioDriver
Definition: SDL_dynapi_overrides.h:83
NULL
#define NULL
Definition: begin_code.h:143

int audio_quitInitAudioSubSystem | ( |  | ) |

Stop and restart audio subsystem.

See also
  https://wiki.libsdl.org/SDL_QuitSubSystem
  https://wiki.libsdl.org/SDL_InitSubSystem

Definition at line 65 of file testautomation_audio.c.

References _audioSetUp(), NULL, SDL_INIT_AUDIO, SDL_QuitSubSystem, SDLTest_AssertPass(), and TEST_COMPLETED.

{
/* Stop SDL audio subsystem */
SDL_QuitSubSystem( SDL_INIT_AUDIO );
SDLTest_AssertPass("Call to SDL_QuitSubSystem(SDL_INIT_AUDIO)");
/* Restart audio again */
_audioSetUp(NULL);
return TEST_COMPLETED;
}
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:62
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
NULL
#define NULL
Definition: begin_code.h:143
SDL_INIT_AUDIO
#define SDL_INIT_AUDIO
Definition: SDL.h:76
_audioSetUp
void _audioSetUp(void *arg)
Definition: testautomation_audio.c:20

## Variable Documentation

int _audio_testCallbackCounter

Definition at line 42 of file testautomation_audio.c.

Referenced by _audio_testCallback(), and audio_pauseUnpauseAudio().

int _audio_testCallbackLength

Definition at line 45 of file testautomation_audio.c.

Referenced by _audio_testCallback(), and audio_pauseUnpauseAudio().

Uint8 _audioChannels[] = { 1, 2, 4, 6 }

Definition at line 505 of file testautomation_audio.c.

Referenced by audio_buildAudioCVT(), and audio_convertAudio().

SDL_AudioFormat _audioFormats[]

Initial value:
= { AUDIO_S8, AUDIO_U8, AUDIO_S16LSB, AUDIO_S16MSB, AUDIO_S16SYS, AUDIO_S16, AUDIO_U16LSB,
AUDIO_U16MSB, AUDIO_U16SYS, AUDIO_U16, AUDIO_S32LSB, AUDIO_S32MSB, AUDIO_S32SYS, AUDIO_S32,
AUDIO_F32LSB, AUDIO_F32MSB, AUDIO_F32SYS, AUDIO_F32 }
AUDIO_S32MSB
#define AUDIO_S32MSB
Definition: SDL_audio.h:104
AUDIO_U16LSB
#define AUDIO_U16LSB
Definition: SDL_audio.h:91
AUDIO_S16SYS
#define AUDIO_S16SYS
Definition: SDL_audio.h:123
AUDIO_F32MSB
#define AUDIO_F32MSB
Definition: SDL_audio.h:113
AUDIO_U8
#define AUDIO_U8
Definition: SDL_audio.h:89
AUDIO_F32SYS
#define AUDIO_F32SYS
Definition: SDL_audio.h:125
AUDIO_F32LSB
#define AUDIO_F32LSB
Definition: SDL_audio.h:112
AUDIO_S32
#define AUDIO_S32
Definition: SDL_audio.h:105
AUDIO_S32LSB
#define AUDIO_S32LSB
Definition: SDL_audio.h:103
AUDIO_S16MSB
#define AUDIO_S16MSB
Definition: SDL_audio.h:94
AUDIO_S16
#define AUDIO_S16
Definition: SDL_audio.h:96
AUDIO_S16LSB
#define AUDIO_S16LSB
Definition: SDL_audio.h:92
AUDIO_S32SYS
#define AUDIO_S32SYS
Definition: SDL_audio.h:124
AUDIO_F32
#define AUDIO_F32
Definition: SDL_audio.h:114
AUDIO_U16
#define AUDIO_U16
Definition: SDL_audio.h:95
AUDIO_S8
#define AUDIO_S8
Definition: SDL_audio.h:90
AUDIO_U16SYS
#define AUDIO_U16SYS
Definition: SDL_audio.h:122
AUDIO_U16MSB
#define AUDIO_U16MSB
Definition: SDL_audio.h:93

Definition at line 498 of file testautomation_audio.c.

Referenced by audio_buildAudioCVT(), and audio_convertAudio().

char* _audioFormatsVerbose[]

Initial value:
= { "AUDIO_S8", "AUDIO_U8", "AUDIO_S16LSB", "AUDIO_S16MSB", "AUDIO_S16SYS", "AUDIO_S16", "AUDIO_U16LSB",
"AUDIO_U16MSB", "AUDIO_U16SYS", "AUDIO_U16", "AUDIO_S32LSB", "AUDIO_S32MSB", "AUDIO_S32SYS", "AUDIO_S32",
"AUDIO_F32LSB", "AUDIO_F32MSB", "AUDIO_F32SYS", "AUDIO_F32" }

Definition at line 501 of file testautomation_audio.c.

Referenced by audio_buildAudioCVT(), and audio_convertAudio().

int _audioFrequencies[] = { 11025, 22050, 44100, 48000 }

Definition at line 507 of file testautomation_audio.c.

Referenced by audio_buildAudioCVT(), and audio_convertAudio().

const int _numAudioChannels = 4

Definition at line 504 of file testautomation_audio.c.

Referenced by audio_buildAudioCVT(), and audio_convertAudio().

const int _numAudioFormats = 18

Definition at line 497 of file testautomation_audio.c.

Referenced by audio_buildAudioCVT(), and audio_convertAudio().

const int _numAudioFrequencies = 4

Definition at line 506 of file testautomation_audio.c.

Referenced by audio_buildAudioCVT(), and audio_convertAudio().

const SDLTest_TestCaseReference audioTest1

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_enumerateAndNameAudioDevices, "audio_enumerateAndNameAudioDevices", "Enumerate and name available audio devices (output and capture)", TEST_ENABLED }
audio_enumerateAndNameAudioDevices
int audio_enumerateAndNameAudioDevices()
Enumerate and name available audio devices (output and capture).
Definition: testautomation_audio.c:346
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 975 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest10

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_convertAudio, "audio_convertAudio", "Convert audio using available formats.", TEST_DISABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_DISABLED
#define TEST_DISABLED
Definition: SDL_test_harness.h:48
audio_convertAudio
int audio_convertAudio()
Convert audio using various conversion structures.
Definition: testautomation_audio.c:817

Definition at line 1005 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest11

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_openCloseAudioDeviceConnected, "audio_openCloseAudioDeviceConnected", "Opens and closes audio device and get connected status.", TEST_DISABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_DISABLED
#define TEST_DISABLED
Definition: SDL_test_harness.h:48
audio_openCloseAudioDeviceConnected
int audio_openCloseAudioDeviceConnected()
Opens, checks current connected status, and closes a device.
Definition: testautomation_audio.c:915

Definition at line 1010 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest12

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_quitInitAudioSubSystem, "audio_quitInitAudioSubSystem", "Quit and re-init audio subsystem.", TEST_ENABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
audio_quitInitAudioSubSystem
int audio_quitInitAudioSubSystem()
Stop and restart audio subsystem.
Definition: testautomation_audio.c:65
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 1013 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest13

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_initQuitAudio, "audio_initQuitAudio", "Init and quit audio drivers directly.", TEST_ENABLED }
audio_initQuitAudio
int audio_initQuitAudio()
Start and stop audio directly.
Definition: testautomation_audio.c:83
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 1016 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest14

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_initOpenCloseQuitAudio, "audio_initOpenCloseQuitAudio", "Cycle through init, open, close and quit with various audio specs.", TEST_ENABLED }
audio_initOpenCloseQuitAudio
int audio_initOpenCloseQuitAudio()
Start, open, close and stop audio.
Definition: testautomation_audio.c:139
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 1019 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest15

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_pauseUnpauseAudio, "audio_pauseUnpauseAudio", "Pause and Unpause audio for various audio specs while testing callback.", TEST_ENABLED }
audio_pauseUnpauseAudio
int audio_pauseUnpauseAudio()
Pause and unpause audio.
Definition: testautomation_audio.c:225
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 1022 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest2

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_enumerateAndNameAudioDevicesNegativeTests, "audio_enumerateAndNameAudioDevicesNegativeTests", "Negative tests around enumeration and naming of audio devices.", TEST_ENABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47
audio_enumerateAndNameAudioDevicesNegativeTests
int audio_enumerateAndNameAudioDevicesNegativeTests()
Negative tests around enumeration and naming of audio devices.
Definition: testautomation_audio.c:404

Definition at line 978 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest3

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_printAudioDrivers, "audio_printAudioDrivers", "Checks available audio driver names.", TEST_ENABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47
audio_printAudioDrivers
int audio_printAudioDrivers()
Checks available audio driver names.
Definition: testautomation_audio.c:451

Definition at line 981 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest4

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_printCurrentAudioDriver, "audio_printCurrentAudioDriver", "Checks current audio driver name with initialized audio.", TEST_ENABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47
audio_printCurrentAudioDriver
int audio_printCurrentAudioDriver()
Checks current audio driver name with initialized audio.
Definition: testautomation_audio.c:483

Definition at line 984 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest5

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_buildAudioCVT, "audio_buildAudioCVT", "Builds various audio conversion structures.", TEST_ENABLED }
audio_buildAudioCVT
int audio_buildAudioCVT()
Builds various audio conversion structures.
Definition: testautomation_audio.c:515
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 987 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest6

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_buildAudioCVTNegative, "audio_buildAudioCVTNegative", "Checks calls with invalid input to SDL_BuildAudioCVT", TEST_ENABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
audio_buildAudioCVTNegative
int audio_buildAudioCVTNegative()
Checkes calls with invalid input to SDL_BuildAudioCVT.
Definition: testautomation_audio.c:579
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 990 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest7

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_getAudioStatus, "audio_getAudioStatus", "Checks current audio status.", TEST_ENABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
audio_getAudioStatus
int audio_getAudioStatus()
Checks current audio status.
Definition: testautomation_audio.c:674
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 993 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest8

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_openCloseAndGetAudioStatus, "audio_openCloseAndGetAudioStatus", "Opens and closes audio device and get audio status.", TEST_ENABLED }
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
audio_openCloseAndGetAudioStatus
int audio_openCloseAndGetAudioStatus()
Opens, checks current audio status, and closes a device.
Definition: testautomation_audio.c:695
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 996 of file testautomation_audio.c.

const SDLTest_TestCaseReference audioTest9

static

Initial value:
=
{ (SDLTest_TestCaseFp)audio_lockUnlockOpenAudioDevice, "audio_lockUnlockOpenAudioDevice", "Locks and unlocks an open audio device.", TEST_ENABLED }
audio_lockUnlockOpenAudioDevice
int audio_lockUnlockOpenAudioDevice()
Locks and unlocks open audio device.
Definition: testautomation_audio.c:754
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 999 of file testautomation_audio.c.

const SDLTest_TestCaseReference* audioTests[]

static

Initial value:
= {
&audioTest1, &audioTest2, &audioTest3, &audioTest4, &audioTest5, &audioTest6,
&audioTest7, &audioTest8, &audioTest9, &audioTest10, &audioTest11,
&audioTest12, &audioTest13, &audioTest14, &audioTest15, NULL
}
audioTest12
static const SDLTest_TestCaseReference audioTest12
Definition: testautomation_audio.c:1013
audioTest14
static const SDLTest_TestCaseReference audioTest14
Definition: testautomation_audio.c:1019
audioTest5
static const SDLTest_TestCaseReference audioTest5
Definition: testautomation_audio.c:987
audioTest9
static const SDLTest_TestCaseReference audioTest9
Definition: testautomation_audio.c:999
audioTest8
static const SDLTest_TestCaseReference audioTest8
Definition: testautomation_audio.c:996
audioTest4
static const SDLTest_TestCaseReference audioTest4
Definition: testautomation_audio.c:984
audioTest2
static const SDLTest_TestCaseReference audioTest2
Definition: testautomation_audio.c:978
audioTest1
static const SDLTest_TestCaseReference audioTest1
Definition: testautomation_audio.c:975
audioTest15
static const SDLTest_TestCaseReference audioTest15
Definition: testautomation_audio.c:1022
NULL
#define NULL
Definition: begin_code.h:143
audioTest6
static const SDLTest_TestCaseReference audioTest6
Definition: testautomation_audio.c:990
audioTest13
static const SDLTest_TestCaseReference audioTest13
Definition: testautomation_audio.c:1016
audioTest11
static const SDLTest_TestCaseReference audioTest11
Definition: testautomation_audio.c:1010
audioTest10
static const SDLTest_TestCaseReference audioTest10
Definition: testautomation_audio.c:1005
audioTest7
static const SDLTest_TestCaseReference audioTest7
Definition: testautomation_audio.c:993
audioTest3
static const SDLTest_TestCaseReference audioTest3
Definition: testautomation_audio.c:981

Definition at line 1026 of file testautomation_audio.c.

SDLTest_TestSuiteReference audioTestSuite

Initial value:
= {
"Audio",
_audioSetUp,
audioTests,
_audioTearDown
}
audioTests
static const SDLTest_TestCaseReference * audioTests[]
Definition: testautomation_audio.c:1026
_audioTearDown
void _audioTearDown(void *arg)
Definition: testautomation_audio.c:32
_audioSetUp
void _audioSetUp(void *arg)
Definition: testautomation_audio.c:20

Reference to all test suites.

Definition at line 1033 of file testautomation_audio.c.